/*
    AllegroTetrus - An implementation of the classic game using the Allegro
    library (version 4) and the Allegro Wrapper
    Copyright (C) 2013, Marco Forte

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "Matrice.h"
Matrice::Matrice()
{
	for (unsigned i=0;i<20;i++)
	{
		for(unsigned j=0;j<10;j++)
		{
			mat[i][j]=0;
		} 
	}
}
		
void Matrice::aggiorna(vector<Point> temp,bool movimento)
{
	for (unsigned i=0;i<20;i++)
	{
		for(unsigned j=0;j<10;j++)
		{
			if(mat[i][j]==1)
			 mat[i][j]=0;		 
		} 
	}
	if (movimento=true)
	{
		mat[(temp[0].getY()-50)/20][(temp[0].getX()-250)/20]=1;
		mat[(temp[1].getY()-50)/20][(temp[1].getX()-250)/20]=1;
		mat[(temp[2].getY()-50)/20][(temp[2].getX()-250)/20]=1;
		mat[(temp[3].getY()-50)/20][(temp[3].getX()-250)/20]=1;
	
	}
}


bool Matrice::scendi(vector<Point> temp,unsigned val)
{

	if( (temp[0].getY()-50)/20==19 || (temp[1].getY()-50)/20==19 || (temp[2].getY()-50)/20==19 || (temp[3].getY()-50)/20==19)
	{
		return false;
	}
		else   
	{
		unsigned temp0=20,temp1=20,temp2=20,temp3=20;
		for (unsigned i=0;i<20;i++)
		{
			if(mat[i][(temp[0].getX()-250)/20]==2)
			{
				 temp0 =i;
				 break;
			}
		}
		for (unsigned i=0;i<20;i++)
		{
			if(mat[i][(temp[1].getX()-250)/20]==2)
			{
				 temp1 =i;
				 break;
			}
		}
		for (unsigned i=0;i<20;i++)
		{
			if(mat[i][(temp[2].getX()-250)/20]==2)
			{
				 temp2 =i;
				 break;
			}
		}
		for (unsigned i=0;i<20;i++)
		{
			if(mat[i][(temp[3].getX()-250)/20]==2)
			{		
	  			 temp3 =i;
	  			 break;
			}
		}
		if( (temp[3].getY()-50)/20==temp3-1 ||
		    (temp[1].getY()-50)/20==temp1-1 ||
		    (temp[2].getY()-50)/20==temp2-1 ||
		    (temp[0].getY()-50)/20==temp0-1 )
		{
			return false;
		}
		else 
			return true;
	}

}


bool Matrice::spostaDx(vector<Point> temp)
{
	if(temp[0].getX()<430 && temp[1].getX()<430 && temp[2].getX()<430 && temp[3].getX()<430)
	{
		if( mat[(temp[0].getY()-50)/20][((temp[0].getX()-250)/20)+1]!=2 &&
		    mat[(temp[1].getY()-50)/20][((temp[1].getX()-250)/20)+1]!=2 &&
		    mat[(temp[2].getY()-50)/20][((temp[2].getX()-250)/20)+1]!=2 &&
		    mat[(temp[3].getY()-50)/20][((temp[3].getX()-250)/20)+1]!=2 )
			{
				return true;
			}
	}
	else
	return false;
}
bool Matrice::spostaDx2(vector<Point> temp)
{

	if(temp[0].getX()<430 && temp[1].getX()<430 && temp[2].getX()<430 && temp[3].getX()<430)
	{
		if( mat[(temp[0].getY()-50)/20][((temp[0].getX()-250)/20)+1]!=2 &&
		    mat[(temp[1].getY()-50)/20][((temp[1].getX()-250)/20)+1]!=2 &&
		    mat[(temp[2].getY()-50)/20][((temp[2].getX()-250)/20)+1]!=2 &&
		    mat[(temp[3].getY()-50)/20][((temp[3].getX()-250)/20)+1]!=2 )
			{
				Point maxDestro=temp[0];
				Point maxBassoDestro=temp[0];
				for(int i=0;i<3;i++)
				{
					if(maxBassoDestro.getY()<temp[i+1].getY() || temp[i].getY()==temp[i+1].getY() && temp[i].getX()<temp[i+1].getX())
					{
						maxBassoDestro=temp[i+1];
					}
					if(maxDestro.getX()<temp[i+1].getX())
					{
						maxDestro=temp[i+1];
					}
				}
				if(mat[((maxDestro.getY()-50)/20)+1][((maxDestro.getX()-250)/20)+1]!=2 &&
				   mat[((maxBassoDestro.getY()-50)/20)+1][((maxBassoDestro.getX()-250)/20)+1]!=2)
				   	return true;
			}
	}
	else
	return false;
}
bool Matrice::spostaSx2(vector<Point> temp)
{
	if(temp[0].getX()>250 && temp[1].getX()>250 && temp[2].getX()>250 && temp[3].getX()>250)
	{
		if( mat[(temp[0].getY()-50)/20][(((temp[0].getX()-250)/20))-1]!=2 &&
		    mat[(temp[1].getY()-50)/20][(((temp[1].getX()-250)/20))-1]!=2 &&
		    mat[(temp[2].getY()-50)/20][(((temp[2].getX()-250)/20))-1]!=2 &&
		    mat[(temp[3].getY()-50)/20][(((temp[3].getX()-250)/20))-1]!=2 )
			{
				Point maxSinistro=temp[0];
				Point maxBassoSinistro=temp[0];
				for(int i=0;i<3;i++)
				{
					if(maxBassoSinistro.getY()<temp[i+1].getY() || temp[i].getY()==temp[i+1].getY() && temp[i].getX()>temp[i+1].getX())
					{
						maxBassoSinistro=temp[i+1];
					}
					if(maxSinistro.getX()>temp[i+1].getX())
					{
						maxSinistro=temp[i+1];
					}
				}
				if(mat[((maxSinistro.getY()-50)/20)+1][((maxSinistro.getX()-250)/20)-1]!=2 &&
				   mat[((maxBassoSinistro.getY()-50)/20)+1][((maxBassoSinistro.getX()-250)/20)-1]!=2)
				   	return true;
			}	
	}
	else
	return false;
}

bool Matrice::spostaSx(vector<Point> temp)
{
	if(temp[0].getX()>250 && temp[1].getX()>250 && temp[2].getX()>250 && temp[3].getX()>250)
	{
		if( mat[(temp[0].getY()-50)/20][(((temp[0].getX()-250)/20))-1]!=2 &&
		    mat[(temp[1].getY()-50)/20][(((temp[1].getX()-250)/20))-1]!=2 &&
		    mat[(temp[2].getY()-50)/20][(((temp[2].getX()-250)/20))-1]!=2 &&
		    mat[(temp[3].getY()-50)/20][(((temp[3].getX()-250)/20))-1]!=2 )
			{
				return true;
			}
	}
	else
	return false;
}


void Matrice::nuovaForma()
{
	for (unsigned i=0;i<20;i++)
	{
		for(unsigned j=0;j<10;j++)
		{
			if(mat[i][j]==1)
				 mat[i][j]=2;		 
		} 
	}
}		


void Matrice::stampa()
{
	for (unsigned i=0;i<20;i++)
	{
		cout<<i<<"  ";
		for(unsigned j=0;j<10;j++)
		{
			cout<<mat[i][j];
		} 
		cout<<endl;
	}
	cout<<endl<<endl;
}
		
bool Matrice::controlloNecessari (vector<Point> necessari)
{
	for(int i=0;i<necessari.size();i++)
	{
		if(mat[(necessari[i].getY()-50)/20][(necessari[i].getX()-250)/20]==2)
			return false;
	}
	return true;
}

bool Matrice::controlloEndGame()
{
	for(unsigned i=0;i<10;i++)
	{
		if(mat[0][i]==1)
			return true;
	}
return false;	
}
vector<int> Matrice::controlloLine()
{
	vector<int> linee;
	for (unsigned i=0;i<20;i++)
	{
		bool line=true;
		for(unsigned j=0;j<10;j++)
		{
			if(mat[i][j]==0)
				line=false; 
		} 
		if(line==true)
		{
			linee.push_back(i);
		}
	}
	return linee;
}

void Matrice::eliminaLine(vector<int> linee)
{
	int contatore=0;
	while(linee.size()!=contatore)
	{
		for(int i=0;i<10;i++)
		{
			for(int j=linee[contatore];j>0;j--)
			{
				mat[j][i]=mat[j-1][i];
			}
			mat[0][i]=0;
		}
		contatore++;
	}
}
