/*
    AllegroTetrus - An implementation of the classic game using the Allegro
    library (version 4) and the Allegro Wrapper
    Copyright (C) 2013, Marco Forte

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef MATRICE_H
#define MATRICE_H
 
#include <iostream>
#include <vector>
#include "Point.h"
using namespace std;

class Matrice
{
	private:
		int mat[20][10];
	public:
		Matrice();
		
		void aggiorna(vector<Point>,bool movimento);
		void nuovaForma();
		
		bool scendi(vector<Point> punti,unsigned val);
		bool spostaDx(vector<Point>);
		bool spostaDx2(vector<Point>);
		bool spostaSx(vector<Point>);
		bool spostaSx2(vector<Point>);		
		bool controlloNecessari (vector<Point>);
		bool controlloEndGame();
		vector<int> controlloLine();
		void eliminaLine(vector<int>);
		
		void stampa();
		
};
#endif


