/*
    AllegroTetrus - An implementation of the classic game using the Allegro
    library (version 4) and the Allegro Wrapper
    Copyright (C) 2013, Marco Forte

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef 	QUADRATOS_H
#define	QUADRATOS_H

#include "Allegro.h"


class QuadratoS : public Sprite
{
public:
	QuadratoS(const string& filename, const Point& leftTopCorner );
	
	    virtual Drawable* clone() const { return new QuadratoS(*this); }	
   // 	virtual bool alive() const{return true;}

   virtual bool alive() const { return !distruggi;}

/*
    const Point& getLeftTopCorner() const { return leftTopCorner; }
    void setLeftTopCorner(const Point& value) 
			{ 
				leftTopCorner = value; 
				Sprite:setLeftTopCorner(value);
			}
	*/		  
  void setDistruggi() {distruggi=true;}
private:
bool distruggi;


};

#endif


